import type { EquipmentViewModel } from "../equipment/equipment.models";
import type {
  InspectionPlanViewModel,
  InspectionVersionedPlanViewModel,
} from "../inspectionPlan/inspectionPlan.models";
import type { VehicleViewModel } from "../vehicle/vehicle.models";

export type InspectionViewModel = {
  id: string;
  inspectionPlanId: string;
  inspectionPlan: InspectionPlanViewModel;
  inspectionVersionedPlanId: string;
  inspectionVersionedPlan: InspectionVersionedPlanViewModel;
  context: string;
  created: Date;
  finished?: Date;
  isOpen: boolean;
  nextInspection?: Date;
  checks: Array<InspectionPointResultViewModel>;
  relatedId: string;
} & (
  | {
      assigned: "equipment";
      related: EquipmentViewModel;
    }
  | {
      assigned: "vehicle";
      related: VehicleViewModel;
    }
);

export interface InspectionPointViewModel {
  id: string;
  title: string;
  description: string;
  type: "iO-niO" | "text" | "number";
  min?: number;
}

export interface InspectionPointResultViewModel {
  inspectionId: string;
  inspectionVersionedPlanId: string;
  inspectionPointId: string;
  value: string;
}
